const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const user_ranks = sequelize.define(
    'user_ranks',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

rank_points: {
        type: DataTypes.INTEGER,
      
      

      },

updated_at_time: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  user_ranks.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity







































//end loop



    db.user_ranks.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.user_ranks.belongsTo(db.rank_tiers, {
      as: 'rank_tier',
      foreignKey: {
        name: 'rank_tierId',
      },
      constraints: false,
    });




    db.user_ranks.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.user_ranks.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return user_ranks;
};


